var timer = null;


function load() {
	timer = null;
	onshow();
}



function onshow() {
	
    if (timer == null) { 
		showTime();
		timer = setInterval("showTime();", 1000);
	}
}


function onhide () { 
    if (timer != null) { 
        clearInterval(timer); 
        timer = null; 
    } 
} 


if (window.widget) {
	widget.onshow = onshow;
	widget.onhide = onhide; 
}


function showTime() {

	var Now = new Date();
	
	var day = Now.getDate();
	var month = Now.getMonth() + 1;
	if (day <= 9)
		day = "0" + day;
	if (month <= 9)
		month = "0" + month;
	var dateString = "";
	
	var langCode = navigator.language;

	// Laenderabhaengige Formatierung
	if (langCode.indexOf("de")  > -1)
		dateString = day +"." +month +"." +Now.getFullYear();
	else if (langCode.indexOf("en")  > -1)
		dateString = month +"/" +day +"/" +Now.getFullYear();
	else
		dateString = day +"/" +month +"/" +Now.getFullYear();
	
	document.getElementById("date").innerHTML = dateString;

	// Zeit formatieren
	var hours = Now.getHours();
	var minutes = Now.getMinutes();
	var seconds = Now.getSeconds();
	if (hours <= 9)
		hours = "0" + hours;
	if (minutes <= 9)
		minutes = "0" + minutes;
	if (seconds <= 9)
		seconds = "0" + seconds;

	var timeString = hours +":" +minutes +":" +seconds;
	
	document.getElementById("time").innerHTML = timeString;

	// Erster Tag des Jahres
	var first = new Date(Now.getFullYear(), 0, 1, 0, 0, 0);
	
	// Ermitteln des aktuellen Tages (DayOfYear)
	var dayOfYear = Now.getTime() - first.getTime();
	dayOfYear = dayOfYear/(3600000*24);
	dayOfYear = Math.ceil(dayOfYear);

	// Berechnung der Anzahl Tage dieses Jahres. 
	var last = new Date(Now.getFullYear(), 11, 32, 0, 0, 0);
	
	var totalDays = last.getTime() - first.getTime();
	totalDays = totalDays/(3600000*24);

	// Berechnung der Sternzeit, auf eine Nachkommastelle kaufmaennisch gerundet
	var stardate = 1000 * (Now.getFullYear() + 1 / totalDays * (dayOfYear - 1 + Now.getHours()/24 + minutes/1440) - 2323) 
	if ((Math.round(stardate*10) % 10) == 0)
		stardate = Math.round(stardate*10)/10 +".0";
	else
		stardate = Math.round(stardate*10)/10

	document.getElementById("stardate").innerHTML = stardate;
	
	// new in version 1.1	
	setKalenderwoche(new Date(Now.getFullYear(), Now.getMonth(), Now.getDate()));

}



// new in version 1.1
function setKalenderwoche(date) {

	var kw = calculateKalenderwoche(new Date(date.getFullYear(), 0, 1), date);

	//Falls in der ersten Jahreswoche die KW von vorherigen Jahr bernommen wird
	if (kw == 0)
		kw = calculateKalenderwoche(new Date(date.getFullYear()-1, 0, 1), new Date(date.getFullYear()-1, 11, 31));
		
	var lastDayOfYear = new Date(date.getFullYear(), 11, 31);
	if (lastDayOfYear.getDay() < 5 && date.getMonth() == 11 && date.getDate() >= 28) {
		var temp = new Date(date.getFullYear(), 11, date.getDate());
		if (temp.getDay() < 5 && temp.getDay() > 0)
			kw = 1;
	}
		
	document.getElementById("weeknumber").innerText = (kw < 10 ? "0" : "") +kw;
}


function calculateKalenderwoche(firstdate, lastdate) {

	var firstDayOfMonth = lastdate;
	var firstDayOfYear = firstdate;

	var day = firstDayOfYear.getDay();
	
	if (day == 0) {
		day = 7;
	}
				
	var korr = 0;
	var kw = 0;
		
	if (day < 5)
		korr = 1;
	
	var time1 = firstDayOfMonth.getTime();
	var time2 = firstDayOfYear.getTime();
	
	kw = ((time1 - time2) / 86400000) +day -1;
	// Rundungfehler beheben um stellenweise falsche Berechnungen zu verhindern
	kw = Math.ceil(kw);	
	
	kw = (Math.floor(kw/7) +korr);

  return kw;
}